CMSIS-DSP: Complex FFT Functions

| CMSIS-DSP Version 1.7.0 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Content | Functions
Complex FFT Functions
Transform Functions

## Content
| Complex FFT Tables

## Functions
void | arm_cfft_f32 (const arm_cfft_instance_f32 *S, float32_t *p1, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Processing function for the floating-point complex FFT. More...
void | arm_cfft_q15 (const arm_cfft_instance_q15 *S, q15_t *p1, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Processing function for Q15 complex FFT. More...
void | arm_cfft_q31 (const arm_cfft_instance_q31 *S, q31_t *p1, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Processing function for the Q31 complex FFT. More...
void | arm_cfft_radix2_f32 (const arm_cfft_radix2_instance_f32 *S, float32_t *pSrc)
| Radix-2 CFFT/CIFFT. More...
arm_status | arm_cfft_radix2_init_f32 (arm_cfft_radix2_instance_f32 *S, uint16_t fftLen, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Initialization function for the floating-point CFFT/CIFFT. More...
arm_status | arm_cfft_radix2_init_q15 (arm_cfft_radix2_instance_q15 *S, uint16_t fftLen, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Initialization function for the Q15 CFFT/CIFFT. More...
arm_status | arm_cfft_radix2_init_q31 (arm_cfft_radix2_instance_q31 *S, uint16_t fftLen, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Initialization function for the Q31 CFFT/CIFFT. More...
void | arm_cfft_radix2_q15 (const arm_cfft_radix2_instance_q15 *S, q15_t *pSrc)
| Processing function for the fixed-point CFFT/CIFFT. More...
void | arm_cfft_radix2_q31 (const arm_cfft_radix2_instance_q31 *S, q31_t *pSrc)
| Processing function for the fixed-point CFFT/CIFFT. More...
void | arm_cfft_radix4_f32 (const arm_cfft_radix4_instance_f32 *S, float32_t *pSrc)
| Processing function for the floating-point Radix-4 CFFT/CIFFT. More...
arm_status | arm_cfft_radix4_init_f32 (arm_cfft_radix4_instance_f32 *S, uint16_t fftLen, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Initialization function for the floating-point CFFT/CIFFT. More...
arm_status | arm_cfft_radix4_init_q15 (arm_cfft_radix4_instance_q15 *S, uint16_t fftLen, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Initialization function for the Q15 CFFT/CIFFT. More...
arm_status | arm_cfft_radix4_init_q31 (arm_cfft_radix4_instance_q31 *S, uint16_t fftLen, uint8_t ifftFlag, uint8_t bitReverseFlag)
| Initialization function for the Q31 CFFT/CIFFT. More...
void | arm_cfft_radix4_q15 (const arm_cfft_radix4_instance_q15 *S, q15_t *pSrc)
| Processing function for the Q15 CFFT/CIFFT. More...
void | arm_cfft_radix4_q31 (const arm_cfft_radix4_instance_q31 *S, q31_t *pSrc)
| Processing function for the Q31 CFFT/CIFFT. More...

## Description

  The Fast Fourier Transform (FFT) is an efficient algorithm for computing the Discrete Fourier Transform (DFT). The FFT can be orders of magnitude faster than the DFT, especially for long lengths. The algorithms described in this section operate on complex data. A separate set of functions is devoted to handling of real sequences.

  There are separate algorithms for handling floating-point, Q15, and Q31 data types. The algorithms available for each data type are described next.

  The FFT functions operate in-place. That is, the array holding the input data will also be used to hold the corresponding result. The input data is complex and contains `2*fftLen` interleaved values as shown below.

      {real[0], imag[0], real[1], imag[1], ...}

  The FFT result will be contained in the same array and the frequency domain values will have the same interleaving.

Floating-point
  The floating-point complex FFT uses a mixed-radix algorithm. Multiple radix-8 stages are performed along with a single radix-2 or radix-4 stage, as needed. The algorithm supports lengths of [16, 32, 64, ..., 4096] and each length uses a different twiddle factor table.

  The function uses the standard FFT definition and output values may grow by a factor of `fftLen` when computing the forward transform. The inverse transform includes a scale of `1/fftLen` as part of the calculation and this matches the textbook definition of the inverse FFT.

  Pre-initialized data structures containing twiddle factors and bit reversal tables are provided and defined in `arm_const_structs.h`. Include this header in your function and then pass one of the constant structures as an argument to arm_cfft_f32. For example:

  `arm_cfft_f32(arm_cfft_sR_f32_len64, pSrc, 1, 1)`

  computes a 64-point inverse complex FFT including bit reversal. The data structures are treated as constant data and not modified during the calculation. The same data structure can be reused for multiple transforms including mixing forward and inverse transforms.

  Earlier releases of the library provided separate radix-2 and radix-4 algorithms that operated on floating-point data. These functions are still provided but are deprecated. The older functions are slower and less general than the new functions.

  An example of initialization of the constants for the arm_cfft_f32 function follows:
  const static arm_cfft_instance_f32 *S;
  ...
  switch (length) {
  case 16:
  S = &arm_cfft_sR_f32_len16;
  break;
  case 32:
  S = &arm_cfft_sR_f32_len32;
  break;
  case 64:
  S = &arm_cfft_sR_f32_len64;
  break;
  case 128:
  S = &arm_cfft_sR_f32_len128;
  break;
  case 256:
  S = &arm_cfft_sR_f32_len256;
  break;
  case 512:
  S = &arm_cfft_sR_f32_len512;
  break;
  case 1024:
  S = &arm_cfft_sR_f32_len1024;
  break;
  case 2048:
  S = &arm_cfft_sR_f32_len2048;
  break;
  case 4096:
  S = &arm_cfft_sR_f32_len4096;
  break;
  }

Q15 and Q31
  The floating-point complex FFT uses a mixed-radix algorithm. Multiple radix-4 stages are performed along with a single radix-2 stage, as needed. The algorithm supports lengths of [16, 32, 64, ..., 4096] and each length uses a different twiddle factor table.

  The function uses the standard FFT definition and output values may grow by a factor of `fftLen` when computing the forward transform. The inverse transform includes a scale of `1/fftLen` as part of the calculation and this matches the textbook definition of the inverse FFT.

  Pre-initialized data structures containing twiddle factors and bit reversal tables are provided and defined in `arm_const_structs.h`. Include this header in your function and then pass one of the constant structures as an argument to arm_cfft_q31. For example:

  `arm_cfft_q31(arm_cfft_sR_q31_len64, pSrc, 1, 1)`

  computes a 64-point inverse complex FFT including bit reversal. The data structures are treated as constant data and not modified during the calculation. The same data structure can be reused for multiple transforms including mixing forward and inverse transforms.

  Earlier releases of the library provided separate radix-2 and radix-4 algorithms that operated on floating-point data. These functions are still provided but are deprecated. The older functions are slower and less general than the new functions.

  An example of initialization of the constants for the arm_cfft_q31 function follows:
  const static arm_cfft_instance_q31 *S;
  ...
  switch (length) {
  case 16:
  S = &arm_cfft_sR_q31_len16;
  break;
  case 32:
  S = &arm_cfft_sR_q31_len32;
  break;
  case 64:
  S = &arm_cfft_sR_q31_len64;
  break;
  case 128:
  S = &arm_cfft_sR_q31_len128;
  break;
  case 256:
  S = &arm_cfft_sR_q31_len256;
  break;
  case 512:
  S = &arm_cfft_sR_q31_len512;
  break;
  case 1024:
  S = &arm_cfft_sR_q31_len1024;
  break;
  case 2048:
  S = &arm_cfft_sR_q31_len2048;
  break;
  case 4096:
  S = &arm_cfft_sR_q31_len4096;
  break;
  }

## Function Documentation

void arm_cfft_f32 | ( | const arm_cfft_instance_f32 * | S,
|  | float32_t * | p1,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Parameters

  [in] | S | points to an instance of the floating-point CFFT structure
  [in,out] | p1 | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place
  [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
  [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

Returns
  none

void arm_cfft_q15 | ( | const arm_cfft_instance_q15 * | S,
|  | q15_t * | p1,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Parameters

  [in] | S | points to an instance of Q15 CFFT structure
  [in,out] | p1 | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place
  [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
  [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

Returns
  none

void arm_cfft_q31 | ( | const arm_cfft_instance_q31 * | S,
|  | q31_t * | p1,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Parameters

  [in] | S | points to an instance of the fixed-point CFFT structure
  [in,out] | p1 | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place
  [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
  [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

Returns
  none

void arm_cfft_radix2_f32 | ( | const arm_cfft_radix2_instance_f32 * | S,
|  | float32_t * | pSrc
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_f32 and will be removed in the future
  Parameters

    [in] | S | points to an instance of the floating-point Radix-2 CFFT/CIFFT structure
    [in,out] | pSrc | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place

  Returns
    none

arm_status arm_cfft_radix2_init_f32 | ( | arm_cfft_radix2_instance_f32 * | S,
|  | uint16_t | fftLen,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_f32 and will be removed in the future.
  Parameters

    [in,out] | S | points to an instance of the floating-point CFFT/CIFFT structure
    [in] | fftLen | length of the FFT
    [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
    [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

  Returns
    execution status
    - ARM_MATH_SUCCESS : Operation successful
    - ARM_MATH_ARGUMENT_ERROR : `fftLen` is not a supported length

Details
  The parameter `ifftFlag` controls whether a forward or inverse transform is computed. Set(=1) ifftFlag for calculation of CIFFT otherwise CFFT is calculated

  The parameter `bitReverseFlag` controls whether output is in normal order or bit reversed order. Set(=1) bitReverseFlag for output to be in normal order otherwise output is in bit reversed order.

  The parameter `fftLen` Specifies length of CFFT/CIFFT process. Supported FFT Lengths are 16, 64, 256, 1024.

  This Function also initializes Twiddle factor table pointer and Bit reversal table pointer.

arm_status arm_cfft_radix2_init_q15 | ( | arm_cfft_radix2_instance_q15 * | S,
|  | uint16_t | fftLen,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q15 and will be removed
  Parameters

    [in,out] | S | points to an instance of the Q15 CFFT/CIFFT structure.
    [in] | fftLen | length of the FFT.
    [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
    [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

  Returns
    execution status
    - ARM_MATH_SUCCESS : Operation successful
    - ARM_MATH_ARGUMENT_ERROR : `fftLen` is not a supported length

Details
  The parameter `ifftFlag` controls whether a forward or inverse transform is computed. Set(=1) ifftFlag for calculation of CIFFT otherwise CFFT is calculated

  The parameter `bitReverseFlag` controls whether output is in normal order or bit reversed order. Set(=1) bitReverseFlag for output to be in normal order otherwise output is in bit reversed order.

  The parameter `fftLen` Specifies length of CFFT/CIFFT process. Supported FFT Lengths are 16, 64, 256, 1024.

  This Function also initializes Twiddle factor table pointer and Bit reversal table pointer.

arm_status arm_cfft_radix2_init_q31 | ( | arm_cfft_radix2_instance_q31 * | S,
|  | uint16_t | fftLen,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q31 and will be removed in the future.
  Parameters

    [in,out] | S | points to an instance of the Q31 CFFT/CIFFT structure
    [in] | fftLen | length of the FFT
    [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
    [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

  Returns
    execution status
    - ARM_MATH_SUCCESS : Operation successful
    - ARM_MATH_ARGUMENT_ERROR : `fftLen` is not a supported length

Details
  The parameter `ifftFlag` controls whether a forward or inverse transform is computed. Set(=1) ifftFlag for calculation of CIFFT otherwise CFFT is calculated

  The parameter `bitReverseFlag` controls whether output is in normal order or bit reversed order. Set(=1) bitReverseFlag for output to be in normal order otherwise output is in bit reversed order.

  The parameter `fftLen` Specifies length of CFFT/CIFFT process. Supported FFT Lengths are 16, 64, 256, 1024.

  This Function also initializes Twiddle factor table pointer and Bit reversal table pointer.

void arm_cfft_radix2_q15 | ( | const arm_cfft_radix2_instance_q15 * | S,
|  | q15_t * | pSrc
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q15 and will be removed in the future.
  Parameters

    [in] | S | points to an instance of the fixed-point CFFT/CIFFT structure
    [in,out] | pSrc | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place

  Returns
    none

void arm_cfft_radix2_q31 | ( | const arm_cfft_radix2_instance_q31 * | S,
|  | q31_t * | pSrc
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q31 and will be removed in the future.
  Parameters

    [in] | S | points to an instance of the fixed-point CFFT/CIFFT structure
    [in,out] | pSrc | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place

  Returns
    none

void arm_cfft_radix4_f32 | ( | const arm_cfft_radix4_instance_f32 * | S,
|  | float32_t * | pSrc
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_f32 and will be removed in the future.
  Parameters

    [in] | S | points to an instance of the floating-point Radix-4 CFFT/CIFFT structure
    [in,out] | pSrc | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place

  Returns
    none

arm_status arm_cfft_radix4_init_f32 | ( | arm_cfft_radix4_instance_f32 * | S,
|  | uint16_t | fftLen,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Deprecated:
  Do not use this function. It has been superceded by arm_cfft_f32 and will be removed in the future.
  Parameters

    [in,out] | S | points to an instance of the floating-point CFFT/CIFFT structure
    [in] | fftLen | length of the FFT
    [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
    [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

  Returns
    execution status
    - ARM_MATH_SUCCESS : Operation successful
    - ARM_MATH_ARGUMENT_ERROR : `fftLen` is not a supported length

Details
  The parameter `ifftFlag` controls whether a forward or inverse transform is computed. Set(=1) ifftFlag for calculation of CIFFT otherwise CFFT is calculated

  The parameter `bitReverseFlag` controls whether output is in normal order or bit reversed order. Set(=1) bitReverseFlag for output to be in normal order otherwise output is in bit reversed order.

  The parameter `fftLen` Specifies length of CFFT/CIFFT process. Supported FFT Lengths are 16, 64, 256, 1024.

  This Function also initializes Twiddle factor table pointer and Bit reversal table pointer.

arm_status arm_cfft_radix4_init_q15 | ( | arm_cfft_radix4_instance_q15 * | S,
|  | uint16_t | fftLen,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q15 and will be removed in the future.
  Parameters

    [in,out] | S | points to an instance of the Q15 CFFT/CIFFT structure
    [in] | fftLen | length of the FFT
    [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
    [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

  Returns
    execution status
    - ARM_MATH_SUCCESS : Operation successful
    - ARM_MATH_ARGUMENT_ERROR : `fftLen` is not a supported length

Details
  The parameter `ifftFlag` controls whether a forward or inverse transform is computed. Set(=1) ifftFlag for calculation of CIFFT otherwise CFFT is calculated

  The parameter `bitReverseFlag` controls whether output is in normal order or bit reversed order. Set(=1) bitReverseFlag for output to be in normal order otherwise output is in bit reversed order.

  The parameter `fftLen` Specifies length of CFFT/CIFFT process. Supported FFT Lengths are 16, 64, 256, 1024.

  This Function also initializes Twiddle factor table pointer and Bit reversal table pointer.

arm_status arm_cfft_radix4_init_q31 | ( | arm_cfft_radix4_instance_q31 * | S,
|  | uint16_t | fftLen,
|  | uint8_t | ifftFlag,
|  | uint8_t | bitReverseFlag
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q31 and will be removed in the future.
  Parameters

    [in,out] | S | points to an instance of the Q31 CFFT/CIFFT structure.
    [in] | fftLen | length of the FFT.
    [in] | ifftFlag | flag that selects transform direction value = 0: forward transform value = 1: inverse transform
    [in] | bitReverseFlag | flag that enables / disables bit reversal of output value = 0: disables bit reversal of output value = 1: enables bit reversal of output

  Returns
    execution status
    - ARM_MATH_SUCCESS : Operation successful
    - ARM_MATH_ARGUMENT_ERROR : `fftLen` is not a supported length

Details
  The parameter `ifftFlag` controls whether a forward or inverse transform is computed. Set(=1) ifftFlag for calculation of CIFFT otherwise CFFT is calculated

  The parameter `bitReverseFlag` controls whether output is in normal order or bit reversed order. Set(=1) bitReverseFlag for output to be in normal order otherwise output is in bit reversed order.

  The parameter `fftLen` Specifies length of CFFT/CIFFT process. Supported FFT Lengths are 16, 64, 256, 1024.

  This Function also initializes Twiddle factor table pointer and Bit reversal table pointer.

void arm_cfft_radix4_q15 | ( | const arm_cfft_radix4_instance_q15 * | S,
|  | q15_t * | pSrc
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q15 and will be removed in the future.
  Parameters

    [in] | S | points to an instance of the Q15 CFFT/CIFFT structure.
    [in,out] | pSrc | points to the complex data buffer. Processing occurs in-place.

  Returns
    none

Input and output formats:
  Internally input is downscaled by 2 for every stage to avoid saturations inside CFFT/CIFFT process. Hence the output format is different for different FFT sizes. The input and output formats for different FFT sizes and number of bits to upscale are mentioned in the tables below for CFFT and CIFFT:

  Input and Output Formats for Q15 CFFT
  Input and Output Formats for Q15 CIFFT

void arm_cfft_radix4_q31 | ( | const arm_cfft_radix4_instance_q31 * | S,
|  | q31_t * | pSrc
| ) |  |

Deprecated:
  Do not use this function. It has been superseded by arm_cfft_q31 and will be removed in the future.
  Parameters

    [in] | S | points to an instance of the Q31 CFFT/CIFFT structure
    [in,out] | pSrc | points to the complex data buffer of size `2*fftLen`. Processing occurs in-place

  Returns
    none

Input and output formats:
  Internally input is downscaled by 2 for every stage to avoid saturations inside CFFT/CIFFT process. Hence the output format is different for different FFT sizes. The input and output formats for different FFT sizes and number of bits to upscale are mentioned in the tables below for CFFT and CIFFT:

  Input and Output Formats for Q31 CFFT
  Input and Output Formats for Q31 CIFFT